=== modified file 'Makefile'
--- Makefile	2008-07-20 03:51:41 +0000
+++ Makefile	2008-07-20 02:52:20 +0000
@@ -1,7 +1,13 @@
-CFLAGS=-Wall -g -std=gnu99
+CFLAGS="-Wall -std=gnu99"
 LDFLAGS=-lgnutls
 
 all: plugbasedclient
 
 clean:
 	rm -f plugbasedclient
+
+client_debug: client
+	mv -f client client.tmp
+	$(MAKE) client CXXFLAGS="$(CXXFLAGS) -DDEBUG -DCERT_ROOT=\\\"./\\\""
+	mv client client_debug
+	mv client.tmp client

=== modified file 'TODO'
--- TODO	2008-07-20 06:33:48 +0000
+++ TODO	2008-07-19 18:43:24 +0000
@@ -1,11 +1,15 @@
 [Client]
-configuration for OpenPGP key and interface
+configuration for cert, key, CA and interface
 IPv4 support
+OpenPGP keys support
 
 [Server]
 config file
+client-list
 run-time communication with server
 
+handle SIGTERM, SIGQUIT, etc.
+
 [Mandos-tools/utilities]
 	List clients
 	Enable client

=== modified file 'mandos-clients.conf'
--- mandos-clients.conf	2008-07-20 06:33:48 +0000
+++ mandos-clients.conf	2008-07-20 02:52:20 +0000
@@ -1,12 +1,10 @@
 # Example
-[foo]
-fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
-secret = Base+64+encoded+OpenPGP+encrypted+data/=
-# secfile = /etc/mandos/foo-secret.txt.asc
-fqdn = foo.example.org
-checker = fping -q -- %%(fqdn)s
-timeout = 10m
-
+#[foo]
+#fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
+#secfile = openpgp/secret.txt.asc
+#fqdn = foo.example.org
+#checker = echo %%(fqdn)s >&2; false
+#
 [braxen_client]
 fingerprint =  7788 2722 5BA7 DE53 9C5A  7CFA 59CF F7CD BD9A 5920
 secret =

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-07-20 03:51:41 +0000
+++ plugbasedclient.c	2008-07-20 02:52:20 +0000
@@ -60,12 +60,12 @@
 	or dirst->d_name[d_name_len - 1] == '~'){
       continue;
     }
-
-    char *filename = malloc(d_name_len + plugindir_len + 2);
+    
+    char *filename = malloc(d_name_len + plugindir_len + 1);
     strcpy(filename, plugindir);
     strcat(filename, "/");
     strcat(filename, dirst->d_name);    
-
+    
     stat(filename, &st);
 
     if (S_ISREG(st.st_mode) and (access(filename, X_OK) == 0)){
@@ -80,7 +80,7 @@
 	close(pipefd[0]);	/* close unused read end of pipe */
 	dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
 	/* create a new modified argument list */
-	char **new_argv = malloc(sizeof(char *) * (argc + 1));
+	char **new_argv = malloc(sizeof(char *) * argc + 1);
 	new_argv[0] = filename;
 	for(int i = 1; i < argc; i++){
 	  new_argv[i] = argv[i];

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-07-20 22:58:26 +0000
+++ plugins.d/mandosclient.c	2008-07-20 02:52:20 +0000
@@ -1,3 +1,16 @@
+/* $Id$ */
+
+/* PLEASE NOTE *
+ * This file demonstrates how to use Avahi's core API, this is
+ * the embeddable mDNS stack for embedded applications.
+ *
+ * End user applications should *not* use this API and should use
+ * the D-Bus or C APIs, please see
+ * client-browse-services.c and glib-integration.c
+ * 
+ * I repeat, you probably do *not* want to use this example.
+ */
+
 /***
   This file is part of avahi.
  
@@ -59,8 +72,6 @@
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-bool debug;
-
 typedef struct {
   gnutls_session_t session;
   gnutls_certificate_credentials_t cred;
@@ -77,10 +88,6 @@
   size_t new_packet_length = 0;
   gpgme_engine_info_t engine_info;
 
-  if (debug){
-    fprintf(stderr, "Attempting to decrypt password from gpg packet\n");
-  }
-  
   /* Init GPGME */
   gpgme_check_version(NULL);
   gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
@@ -136,37 +143,27 @@
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
-
-  if(debug){
-    fprintf(stderr, "decryption of gpg packet succeeded\n");
-  }
-
-  if (debug){
-    gpgme_decrypt_result_t result;
-    result = gpgme_op_decrypt_result(ctx);
-    if (result == NULL){
-      fprintf(stderr, "gpgme_op_decrypt_result failed\n");
-    } else {
-      fprintf(stderr, "Unsupported algorithm: %s\n", result->unsupported_algorithm);
-      fprintf(stderr, "Wrong key usage: %d\n", result->wrong_key_usage);
-      if(result->file_name != NULL){
-	fprintf(stderr, "File name: %s\n", result->file_name);
-      }
-      gpgme_recipient_t recipient;
-      recipient = result->recipients;
-      if(recipient){
-	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
-		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
-		  recipient->status == GPG_ERR_NO_SECKEY ? "No" : "Yes");
-	  recipient = recipient->next;
-	}
-      }
-    }
-  }
   
+/*   gpgme_decrypt_result_t result; */
+/*   result = gpgme_op_decrypt_result(ctx); */
+/*   fprintf(stderr, "Unsupported algorithm: %s\n", result->unsupported_algorithm); */
+/*   fprintf(stderr, "Wrong key usage: %d\n", result->wrong_key_usage); */
+/*   if(result->file_name != NULL){ */
+/*     fprintf(stderr, "File name: %s\n", result->file_name); */
+/*   } */
+/*   gpgme_recipient_t recipient; */
+/*   recipient = result->recipients; */
+/*   if(recipient){ */
+/*     while(recipient != NULL){ */
+/*       fprintf(stderr, "Public key algorithm: %s\n", */
+/* 	      gpgme_pubkey_algo_name(recipient->pubkey_algo)); */
+/*       fprintf(stderr, "Key ID: %s\n", recipient->keyid); */
+/*       fprintf(stderr, "Secret key available: %s\n", */
+/* 	      recipient->status == GPG_ERR_NO_SECKEY ? "No" : "Yes"); */
+/*       recipient = recipient->next; */
+/*     } */
+/*   } */
+
   /* Delete the GPGME FILE pointer cryptotext data buffer */
   gpgme_data_release(dh_crypto);
   
@@ -197,10 +194,6 @@
     new_packet_length += ret;
   }
 
-  if(debug){
-    fprintf(stderr, "decrypted password is: %s\n", *new_packet);
-  }
-
    /* Delete the GPGME plaintext data buffer */
   gpgme_data_release(dh_plain);
   return new_packet_length;
@@ -220,11 +213,6 @@
 int initgnutls(encrypted_session *es){
   const char *err;
   int ret;
-
-  if(debug){
-    fprintf(stderr, "Initializing gnutls\n");
-  }
-
   
   if ((ret = gnutls_global_init ())
       != GNUTLS_E_SUCCESS) {
@@ -232,11 +220,10 @@
     return -1;
   }
 
-  if (debug){
-    gnutls_global_set_log_level(11);
-    gnutls_global_set_log_function(debuggnutls);
-  }
-  
+  /* Uncomment to enable full debuggin on the gnutls library */
+  /*   gnutls_global_set_log_level(11); */
+  /*   gnutls_global_set_log_function(debuggnutls); */
+
 
   /* openpgp credentials */
   if ((ret = gnutls_certificate_allocate_credentials (&es->cred))
@@ -245,11 +232,6 @@
     return -1;
   }
 
-  if(debug){
-    fprintf(stderr, "Attempting to use openpgp certificate %s"
-	    " and keyfile %s as gnutls credentials\n", CERTFILE, KEYFILE);
-  }
-
   ret = gnutls_certificate_set_openpgp_key_file
     (es->cred, CERTFILE, KEYFILE, GNUTLS_OPENPGP_FMT_BASE64);
   if (ret != GNUTLS_E_SUCCESS) {
@@ -322,23 +304,15 @@
   size_t buffer_capacity = 0;
   ssize_t decrypted_buffer_size;
   int retval = 0;
-  const char interface[] = "eth0";
 
-  if(debug){
-    fprintf(stderr, "Setting up a tcp connection to %s\n", ip);
-  }
   
   tcp_sd = socket(PF_INET6, SOCK_STREAM, 0);
   if(tcp_sd < 0) {
     perror("socket");
     return -1;
   }
-
-  if(debug){
-    fprintf(stderr, "Binding to interface %s\n", interface);
-  }
-
-  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, interface, 5);
+  
+  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
   if(tcp_sd < 0) {
     perror("setsockopt bindtodevice");
     return -1;
@@ -356,11 +330,7 @@
     return -1;
   }
   to.sin6_port = htons(port);
-  to.sin6_scope_id = if_nametoindex(interface);
-
-  if(debug){
-    fprintf(stderr, "Connection to: %s\n", ip);
-  }
+  to.sin6_scope_id = if_nametoindex("eth0");
   
   ret = connect(tcp_sd, (struct sockaddr *) &to, sizeof(to));
   if (ret < 0){
@@ -377,11 +347,6 @@
   
   gnutls_transport_set_ptr (es.session, (gnutls_transport_ptr_t) tcp_sd);
 
-  if(debug){
-    fprintf(stderr, "Establishing tls session with %s\n", ip);
-  }
-
-  
   ret = gnutls_handshake (es.session);
   
   if (ret != GNUTLS_E_SUCCESS){
@@ -391,12 +356,7 @@
     goto exit;
   }
 
-  //Retrieve gpg packet that contains the wanted password
-
-  if(debug){
-    fprintf(stderr, "Retrieving pgp encrypted password from %s\n", ip);
-  }
-
+  //retrive password
   while(true){
     if (buffer_length + BUFFER_SIZE > buffer_capacity){
       buffer = realloc(buffer, buffer_capacity + BUFFER_SIZE);
@@ -436,23 +396,19 @@
       buffer_length += ret;
     }
   }
-  
+
   if (buffer_length > 0){
-    if ((decrypted_buffer_size = gpg_packet_decrypt(buffer, buffer_length, &decrypted_buffer, CERT_ROOT)) >= 0){
+    if ((decrypted_buffer_size = gpg_packet_decrypt(buffer, buffer_length, &decrypted_buffer, CERT_ROOT)) == 0){
+      retval = -1;
+    } else {
       fwrite (decrypted_buffer, 1, decrypted_buffer_size, stdout);
       free(decrypted_buffer);
-    } else {
-      retval = -1;
     }
   }
 
+  free(buffer);
+
   //shutdown procedure
-
-  if(debug){
-    fprintf(stderr, "Closing tls session\n");
-  }
-
-  free(buffer);
   gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
  exit:
   close(tcp_sd);
@@ -492,9 +448,6 @@
         case AVAHI_RESOLVER_FOUND: {
 	  char ip[AVAHI_ADDRESS_STR_MAX];
             avahi_address_snprint(ip, sizeof(ip), address);
-	    if(debug){
-	      fprintf(stderr, "Mandos server found at %s on port %d\n", ip, port);
-	    }
 	    int ret = start_mandos_communcation(ip, port);
 	    if (ret == 0){
 	      exit(EXIT_SUCCESS);
@@ -553,39 +506,10 @@
 int main(AVAHI_GCC_UNUSED int argc, AVAHI_GCC_UNUSED char*argv[]) {
     AvahiServerConfig config;
     AvahiSServiceBrowser *sb = NULL;
-    const char db[] = "--debug";
     int error;
     int ret = 1;
-    int returncode = EXIT_SUCCESS;
-    char *basename = rindex(argv[0], '/');
-    if(basename == NULL){
-      basename = argv[0];
-    } else {
-      basename++;
-    }
-    
-    char *program_name = malloc(strlen(basename) + sizeof(db));
-
-    if (program_name == NULL){
-      perror("argv[0]");
-      return EXIT_FAILURE;
-    }
-    
-    program_name[0] = '\0';
-    
-    for (int i = 1; i < argc; i++){
-      if (not strncmp(argv[i], db, 5)){
-	  strcat(strcat(strcat(program_name, db ), "="), basename);
-	  if(not strcmp(argv[i], db) or not strcmp(argv[i], program_name)){
-	    debug = true;
-	  }
-	}
-    }
-    free(program_name);
-
-    if (not debug){
-      avahi_set_log_function(empty_log);
-    }
+
+    avahi_set_log_function(empty_log);
     
     /* Initialize the psuedo-RNG */
     srand(time(NULL));
@@ -593,8 +517,7 @@
     /* Allocate main loop object */
     if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	
-        goto exit;
+        goto fail;
     }
 
     /* Do not publish any local records */
@@ -604,39 +527,35 @@
     config.publish_workstation = 0;
     config.publish_domain = 0;
 
+/*     /\* Set a unicast DNS server for wide area DNS-SD *\/ */
+/*     avahi_address_parse("193.11.177.11", AVAHI_PROTO_UNSPEC, &config.wide_area_servers[0]); */
+/*     config.n_wide_area_servers = 1; */
+/*     config.enable_wide_area = 1; */
+    
     /* Allocate a new server */
     server = avahi_server_new(avahi_simple_poll_get(simple_poll), &config, NULL, NULL, &error);
 
     /* Free the configuration data */
     avahi_server_config_free(&config);
 
-    /* Check if creating the server object succeeded */
+    /* Check wether creating the server object succeeded */
     if (!server) {
         fprintf(stderr, "Failed to create server: %s\n", avahi_strerror(error));
-	returncode = EXIT_FAILURE;
-        goto exit;
+        goto fail;
     }
     
     /* Create the service browser */
     if (!(sb = avahi_s_service_browser_new(server, if_nametoindex("eth0"), AVAHI_PROTO_INET6, "_mandos._tcp", NULL, 0, browse_callback, server))) {
         fprintf(stderr, "Failed to create service browser: %s\n", avahi_strerror(avahi_server_errno(server)));
-	returncode = EXIT_FAILURE;
-        goto exit;
+        goto fail;
     }
     
     /* Run the main loop */
-
-    if (debug){
-      fprintf(stderr, "Starting avahi loop search\n");
-    }
-    
     avahi_simple_poll_loop(simple_poll);
     
-exit:
-
-    if (debug){
-      fprintf(stderr, "%s exiting\n", argv[0]);
-    }
+    ret = 0;
+    
+fail:
     
     /* Cleanup things */
     if (sb)

=== modified file 'server.py'
--- server.py	2008-07-20 06:33:48 +0000
+++ server.py	2008-07-20 02:52:20 +0000
@@ -1,5 +1,4 @@
 #!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
 
 from __future__ import division
 
@@ -22,8 +21,6 @@
 import signal
 from sets import Set
 import subprocess
-import atexit
-import stat
 
 import dbus
 import gobject
@@ -34,13 +31,10 @@
 import logging
 import logging.handlers
 
+# logghandler.setFormatter(logging.Formatter('%(levelname)s %(message)s')
+
 logger = logging.Logger('mandos')
-syslogger = logging.handlers.SysLogHandler\
-            (facility = logging.handlers.SysLogHandler.LOG_DAEMON)
-syslogger.setFormatter(logging.Formatter\
-                        ('%(levelname)s: %(message)s'))
-logger.addHandler(syslogger)
-del syslogger
+logger.addHandler(logging.handlers.SysLogHandler(facility = logging.handlers.SysLogHandler.LOG_DAEMON))
 
 # This variable is used to optionally bind to a specified interface.
 # It is a global variable to fit in with the other variables from the
@@ -113,8 +107,8 @@
                         _set_interval)
     del _set_interval
     def __init__(self, name=None, options=None, stop_hook=None,
-                 fingerprint=None, secret=None, secfile=None,
-                 fqdn=None, timeout=None, interval=-1, checker=None):
+                 fingerprint=None, secret=None, secfile=None, fqdn=None,
+                 timeout=None, interval=-1, checker=None):
         self.name = name
         # Uppercase and remove spaces from fingerprint
         # for later comparison purposes with return value of
@@ -133,13 +127,13 @@
         self.created = datetime.datetime.now()
         self.last_seen = None
         if timeout is None:
-            self.timeout = options.timeout
-        else:
-            self.timeout = string_to_delta(timeout)
+            timeout = options.timeout
+        self.timeout = timeout
         if interval == -1:
-            self.interval = options.interval
+            interval = options.interval
         else:
-            self.interval = string_to_delta(interval)
+            interval = string_to_delta(interval)
+        self.interval = interval
         self.stop_hook = stop_hook
         self.checker = None
         self.checker_initiator_tag = None
@@ -199,7 +193,7 @@
             self.stop_initiator_tag = gobject.timeout_add\
                                       (self._timeout_milliseconds,
                                        self.stop)
-        elif not os.WIFEXITED(condition):
+        if not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
         else:
@@ -212,6 +206,8 @@
         If a checker already exists, leave it running and do
         nothing."""
         if self.checker is None:
+            logger.debug(u"Starting checker for %s",
+                         self.name)
             try:
                 command = self.check_command % self.fqdn
             except TypeError:
@@ -221,19 +217,19 @@
                 try:
                     command = self.check_command % escaped_attrs
                 except TypeError, error:
-                    logger.critical(u'Could not format string "%s":'
-                                    u' %s', self.check_command, error)
+                    logger.critical(u'Could not format string "%s": %s',
+                                    self.check_command, error)
                     return True # Try again later
             try:
-                logger.debug(u"Starting checker %r for %s",
-                             command, self.name)
                 self.checker = subprocess.\
                                Popen(command,
+                                     stdout=subprocess.PIPE,
                                      close_fds=True, shell=True,
                                      cwd="/")
-                self.checker_callback_tag = gobject.child_watch_add\
-                                            (self.checker.pid,
-                                             self.checker_callback)
+                self.checker_callback_tag = gobject.\
+                                            child_watch_add(self.checker.pid,
+                                                            self.\
+                                                            checker_callback)
             except subprocess.OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
@@ -260,7 +256,6 @@
 
 
 def peer_certificate(session):
-    "Return an OpenPGP data packet string for the peer's certificate"
     # If not an OpenPGP certificate...
     if gnutls.library.functions.gnutls_certificate_type_get\
             (session._c_object) \
@@ -277,7 +272,6 @@
 
 
 def fingerprint(openpgp):
-    "Convert an OpenPGP data string to a hexdigit fingerprint string"
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
     gnutls.library.functions.gnutls_openpgp_crt_init\
@@ -509,13 +503,15 @@
             add_service()
             
         else:
-            logger.error(u"No suitable service name found after %i"
-                         u" retries, exiting.", n_rename)
-            killme(1)
+            logger.error(u"No suitable service name found "
+                         u"after %i retries, exiting.",
+                         n_rename)
+            main_loop.quit()
     elif state == avahi.ENTRY_GROUP_FAILURE:
         logger.error(u"Error in group state changed %s",
                      unicode(error))
-        killme(1)
+        main_loop.quit()
+        return
 
 
 def if_nametoindex(interface):
@@ -537,43 +533,23 @@
         return interface_index
 
 
-def daemon(nochdir, noclose):
-    """See daemon(3).  Standard BSD Unix function.
-    This should really exist as os.daemon, but it doesn't (yet)."""
-    if os.fork():
-        sys.exit()
-    os.setsid()
-    if not nochdir:
-        os.chdir("/")
-    if not noclose:
-        # Close all standard open file descriptors
-        null = os.open("/dev/null", os.O_NOCTTY | os.O_RDWR)
-        if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV,
-                          "/dev/null not a character device")
-        os.dup2(null, sys.stdin.fileno())
-        os.dup2(null, sys.stdout.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        if null > 2:
-            os.close(null)
-
-
-def killme(status = 0):
-    logger.debug("Stopping server with exit status %d", status)
-    exitstatus = status
-    if main_loop_started:
-        main_loop.quit()
-    else:
-        sys.exit(status)
-
-
 if __name__ == '__main__':
-    exitstatus = 0
-    main_loop_started = False
     parser = OptionParser()
     parser.add_option("-i", "--interface", type="string",
                       default=None, metavar="IF",
                       help="Bind to interface IF")
+    parser.add_option("--cert", type="string", default="cert.pem",
+                      metavar="FILE",
+                      help="Public key certificate PEM file to use")
+    parser.add_option("--key", type="string", default="key.pem",
+                      metavar="FILE",
+                      help="Private key PEM file to use")
+    parser.add_option("--ca", type="string", default="ca.pem",
+                      metavar="FILE",
+                      help="Certificate Authority certificate PEM file to use")
+    parser.add_option("--crl", type="string", default="crl.pem",
+                      metavar="FILE",
+                      help="Certificate Revokation List PEM file to use")
     parser.add_option("-p", "--port", type="int", default=None,
                       help="Port number to receive requests on")
     parser.add_option("--timeout", type="string", # Parsed later
@@ -604,7 +580,7 @@
         parser.error("option --interval: Unparseable time")
     
     # Parse config file
-    defaults = { "checker": "fping -q -- %%(fqdn)s" }
+    defaults = { "checker": "sleep 1; fping -q -- %%(fqdn)s" }
     client_config = ConfigParser.SafeConfigParser(defaults)
     #client_config.readfp(open("secrets.conf"), "secrets.conf")
     client_config.read("mandos-clients.conf")
@@ -620,50 +596,18 @@
     
     debug = options.debug
     
-    if debug:
-        console = logging.StreamHandler()
-        # console.setLevel(logging.DEBUG)
-        console.setFormatter(logging.Formatter\
-                             ('%(levelname)s: %(message)s'))
-        logger.addHandler(console)
-        del console
-    
     clients = Set()
     def remove_from_clients(client):
         clients.remove(client)
         if not clients:
             logger.debug(u"No clients left, exiting")
-            killme()
+            main_loop.quit()
     
     clients.update(Set(Client(name=section, options=options,
                               stop_hook = remove_from_clients,
                               **(dict(client_config\
                                       .items(section))))
                        for section in client_config.sections()))
-    
-    if not debug:
-        daemon(False, False)
-    
-    def cleanup():
-        "Cleanup function; run on exit"
-        global group
-        # From the Avahi server example code
-        if not group is None:
-            group.Free()
-            group = None
-        # End of Avahi example code
-        
-        for client in clients:
-            client.stop_hook = None
-            client.stop()
-    
-    atexit.register(cleanup)
-    
-    if not debug:
-        signal.signal(signal.SIGINT, signal.SIG_IGN)
-    signal.signal(signal.SIGHUP, lambda signum, frame: killme())
-    signal.signal(signal.SIGTERM, lambda signum, frame: killme())
-    
     for client in clients:
         client.start()
     
@@ -680,11 +624,7 @@
     
     # From the Avahi server example code
     server.connect_to_signal("StateChanged", server_state_changed)
-    try:
-        server_state_changed(server.GetState())
-    except dbus.exceptions.DBusException, error:
-        logger.critical(u"DBusException: %s", error)
-        killme(1)
+    server_state_changed(server.GetState())
     # End of Avahi example code
     
     gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
@@ -692,10 +632,17 @@
                          tcp_server.handle_request(*args[2:],
                                                    **kwargs) or True)
     try:
-        main_loop_started = True
         main_loop.run()
     except KeyboardInterrupt:
-        if debug:
-            print
-    
-    sys.exit(exitstatus)
+        print
+    
+    # Cleanup here
+
+    # From the Avahi server example code
+    if not group is None:
+        group.Free()
+    # End of Avahi example code
+    
+    for client in clients:
+        client.stop_hook = None
+        client.stop()

